



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Spring 4 and MyBatis Java Config</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Spring 4 and MyBatis Java Config</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 01:05:55 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>TL;DR</h1>
<p>With the Java Config enhancements in Spring 4, you no longer need xml to configure MyBatis for your Spring application. Using the&nbsp;<strong><a href="https://mybatis.github.io/spring/apidocs/reference/org/mybatis/spring/annotation/MapperScan.html" rel="external nofollow noreferrer"><code>@MapperScan</code></a></strong>annotation provided by the&nbsp;<a href="http://mybatis.github.io/spring/" rel="external nofollow noreferrer">mybatis-spring</a>&nbsp;library, you can perform a package-level scan for MyBatis domain mappers. When combined with Servlet 3+, you can configure and run your application without any XML (aside from the MyBatis query definitions). This post is a long overdue follow up to a&nbsp;<a href="http://blog.lanyonm.org/articles/2013/01/19/mybatis-spring-java-config-contribution.html" rel="external nofollow noreferrer">previous post</a>&nbsp;about my contribution to this code.</p>
<h2>Class Overview</h2>
<p>Use this annotation to register MyBatis mapper interfaces when using Java Config. It performs when same work as&nbsp;<code><a href="http://www.mybatis.org/spring/apidocs/reference/org/mybatis/spring/mapper/MapperScannerConfigurer.html" rel="external nofollow noreferrer">MapperScannerConfigurer</a></code>&nbsp;via&nbsp;<code><a href="http://www.mybatis.org/spring/apidocs/reference/org/mybatis/spring/annotation/MapperScannerRegistrar.html" rel="external nofollow noreferrer">MapperScannerRegistrar</a></code>.</p>
<p>Configuration example:</p>
<pre class="prettyprint linenums">&nbsp;@Configuration<br />&nbsp;@MapperScan("org.mybatis.spring.sample.mapper")<br />&nbsp;public class AppConfig {

&nbsp; &nbsp;@Bean<br />&nbsp; &nbsp;public DataSource dataSource() {<br />&nbsp; &nbsp; &nbsp;return new EmbeddedDatabaseBuilder()<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; .addScript("schema.sql")<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; .build();<br />&nbsp; &nbsp;}

&nbsp; &nbsp;@Bean<br />&nbsp; &nbsp;public DataSourceTransactionManager transactionManager() {<br />&nbsp; &nbsp; &nbsp;return new DataSourceTransactionManager(dataSource());<br />&nbsp; &nbsp;}

&nbsp; &nbsp;@Bean<br />&nbsp; &nbsp;public SqlSessionFactory sqlSessionFactory() throws Exception {<br />&nbsp; &nbsp; &nbsp;SqlSessionFactoryBean sessionFactory = new SqlSessionFactoryBean();<br />&nbsp; &nbsp; &nbsp;sessionFactory.setDataSource(dataSource());<br />&nbsp; &nbsp; &nbsp;return sessionFactory.getObject();<br />&nbsp; &nbsp;}<br />&nbsp;}<br />&nbsp;</pre>
<div>
<h5>See Also</h5>
<ul><li><code><a href="http://www.mybatis.org/spring/apidocs/reference/org/mybatis/spring/annotation/MapperScannerRegistrar.html" rel="external nofollow noreferrer">MapperScannerRegistrar</a></code></li>
<li><code><a href="http://www.mybatis.org/spring/apidocs/reference/org/mybatis/spring/mapper/MapperFactoryBean.html" rel="external nofollow noreferrer">MapperFactoryBean</a></code></li></ul>
</div>
<div><img referrerpolicy="no-referrer"src="https://spring.io/img/spring-by-pivotal.png" />&nbsp;+&nbsp;<img referrerpolicy="no-referrer"src="https://mybatis.github.io/images/mybatis-logo.png" /></div>
<p><strong><em>Please note</em></strong>: The examples shown here work with Spring 4.0.6 and 4.2.4. Check the master branch on GitHub for updates to the version of Spring compatible with these examples.</p>
<h1>A Java Config Appetizer</h1>
<p>There is a lot of conflicting information out there for those searching for how to implement Spring&rsquo;s Java Config. Be sure to check the version of Spring used in the example because it may not match your target version. This example uses Spring Framework 4.0.6 and MyBatis 3.2.7. As not to get into the weeds of Java Config for a Spring MCV application, we&rsquo;ll cover just the pertinent parts to integrating MyBatis with Java Config.</p>
<p>Have a look at the file structure below. The&nbsp;<a href="https://github.com/lanyonm/playground/blob/28c34b185ca796e1e1b18d4134d1a147c6996b97/src/main/java/org/lanyonm/playground/config/AppInitializer.java" rel="external nofollow noreferrer"><code>AppInitializer</code></a>&nbsp;with its<code>AbstractAnnotationConfigDispatcherServletInitializer</code>&nbsp;super class is where life begins for the application. The&nbsp;<code>getRootConfigClasses()</code>&nbsp;method returns the<code>DataConfg</code>&nbsp;class amongst others not pictured below.</p>
<p>File structure:</p>
<div>
<pre class="prettyprint linenums"><code>- src/main<br />
    - java/org/lanyonm/playground<br />
        - config<br />
            * AppInitializer.java<br />
            * DataConfig.java<br />
        - domain<br />
            * User.java<br />
        - persistence<br />
            * UserMapper.java<br />
    - resources/org/lanyonm/playground<br />
        - persistence<br />
            * UserMapper.xml<br />
* pom.xml<br />
</code></pre>
</div>
<p>It&rsquo;s my preference to put all the&nbsp;<code>@Component</code>&nbsp;or&nbsp;<code>@Configuration</code>&nbsp;classes into the config package so it&rsquo;s easy to locate where the application components are configured.</p>
<h1>The Key Files</h1>
<p>There are four main files in this example. The first and most important is<code>DataConfig.java</code>&nbsp;because it&rsquo;s where the&nbsp;<code>@MapperScan</code>&nbsp;annotation is used. On line 2, you see the package where the MyBatis mappers reside. The three&nbsp;<code>@Bean</code>annotated methods provide the Java Config equivalent to what you would typically see in xml configuration for MyBatis. In this case a<code>SimpleDriverDataSource</code>&nbsp;is used in place of a full-blown DataSource and specifies an in-memory H2 database. In future iterations of this application I will show how to use Spring&rsquo;s Profiles to specify different DataSource implementations depending on the environment.</p>
<p>org.lanyonm.playground.config.<a href="https://github.com/lanyonm/playground/blob/28c34b185ca796e1e1b18d4134d1a147c6996b97/src/main/java/org/lanyonm/playground/config/DataConfig.java" rel="external nofollow noreferrer"><code>DataConfig.java</code></a>:</p>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4<br />
5<br />
6<br />
7<br />
8<br />
9<br />
10<br />
11<br />
12<br />
13<br />
14<br />
15<br />
16<br />
17<br />
18<br />
19<br />
20<br />
21<br />
22<br />
23<br />
24<br />
25<br />
26<br />
27<br />
28<br />
29<br />
30<br />
31<br />
32<br />
33<br />
34<br />
35</pre>
</td>
<td>
<pre class="prettyprint linenums">@Configuration<br />
@MapperScan("org.lanyonm.playground.persistence")<br />
public class DataConfig {

    @Bean<br />
    public DataSource dataSource() {<br />
        SimpleDriverDataSource dataSource = new SimpleDriverDataSource();<br />
        dataSource.setDriverClass(org.h2.Driver.class);<br />
        dataSource.setUsername("sa");<br />
        dataSource.setUrl("jdbc:h2:mem:testdb;DB_CLOSE_DELAY=-1;DB_CLOSE_ON_EXIT=FALSE");<br />
        dataSource.setPassword("");

        // create a table and populate some data<br />
        JdbcTemplate jdbcTemplate = new JdbcTemplate(dataSource);<br />
        System.out.println("Creating tables");<br />
        jdbcTemplate.execute("drop table users if exists");<br />
        jdbcTemplate.execute("create table users(id serial, firstName varchar(255), lastName varchar(255), email varchar(255))");<br />
        jdbcTemplate.update("INSERT INTO users(firstName, lastName, email) values (?,?,?)", "Mike", "Lanyon", "lanyonm@gmail.com");

        return dataSource;<br />
    }

    @Bean<br />
    public DataSourceTransactionManager transactionManager() {<br />
        return new DataSourceTransactionManager(dataSource());<br />
    }

    @Bean<br />
    public SqlSessionFactoryBean sqlSessionFactory() throws Exception {<br />
        SqlSessionFactoryBean sessionFactory = new SqlSessionFactoryBean();<br />
        sessionFactory.setDataSource(dataSource());<br />
        sessionFactory.setTypeAliasesPackage("org.lanyonm.playground.domain");<br />
        return sessionFactory;<br />
    }<br />
}</pre>
</td>
</tr>
</tbody>
</table>
<p>The second important piece of&nbsp;<code>DataConfig</code>&nbsp;is on line 32 where we set the package containing the domain objects that will be available as types in the MyBatis xml files. Returning Java objects from SQL queries is why we go to all this ORM trouble after all.</p>
<p>The User domain object is really just a simple POJO. I&rsquo;ve omitted the getters and setters for brevity.</p>
<p>org.lanyonm.playground.domain.<a href="https://github.com/lanyonm/playground/blob/28c34b185ca796e1e1b18d4134d1a147c6996b97/src/main/java/org/lanyonm/playground/domain/User.java" rel="external nofollow noreferrer"><code>User.java</code></a>:</p>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4<br />
5<br />
6<br />
7<br />
8<br />
9<br />
10<br />
11</pre>
</td>
<td>
<pre class="prettyprint linenums">public class User implements Serializable {

    private static final long serialVersionUID = 1L;<br />
    private long id;<br />
    private String firstName;<br />
    private String lastName;<br />
    private String email;

    // getters and setters

}</pre>
</td>
</tr>
</tbody>
</table>
<p>MyBatis Mapper classes are simple interfaces with method definitions that match with a sql statement defined in the corresponding mapper xml. It is possible to write simple sql statements in annotations instead of defining the sql in xml, but the syntax becomes cumbersome quickly and doesn&rsquo;t allow for complex queries.</p>
<p>org.lanyonm.playground.persistence.<a href="https://github.com/lanyonm/playground/blob/28c34b185ca796e1e1b18d4134d1a147c6996b97/src/main/java/org/lanyonm/playground/persistence/UserMapper.java" rel="external nofollow noreferrer"><code>UserMapper.java</code></a>:</p>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4<br />
5<br />
6<br />
7<br />
8<br />
9<br />
10<br />
11<br />
12<br />
13<br />
14<br />
15<br />
16</pre>
</td>
<td>
<pre class="prettyprint linenums">public interface UserMapper {<br />
    /**<br />
     * @return all the users<br />
     */<br />
    public List&lt;User&gt; getAllUsers();<br />
    /**<br />
     * @param user<br />
     * @return the number of rows affected<br />
     */<br />
    public int insertUser(User user);<br />
    /**<br />
     * @param user<br />
     * @return the number of rows affected<br />
     */<br />
    public int updateUser(User user);<br />
}</pre>
</td>
</tr>
</tbody>
</table>
<p>I haven&rsquo;t done anything special with the MyBatis xml, just a few simple statements.</p>
<p>org.lanyonm.playground.persistence.<a href="https://github.com/lanyonm/playground/blob/28c34b185ca796e1e1b18d4134d1a147c6996b97/src/main/resources/org/lanyonm/playground/persistence/UserMapper.xml" rel="external nofollow noreferrer"><code>UserMapper.xml</code></a>:</p>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4<br />
5<br />
6<br />
7<br />
8<br />
9<br />
10<br />
11<br />
12<br />
13<br />
14<br />
15<br />
16<br />
17<br />
18<br />
19<br />
20<br />
21</pre>
</td>
<td>
<pre class="prettyprint linenums">&lt;!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd"&gt;<br />
&lt;mapper namespace="org.lanyonm.playground.persistence.UserMapper"&gt;<br />
    &lt;cache /&gt;

    &lt;select id="getAllUsers" resultType="User"&gt;<br />
        SELECT id, firstName, lastName, email FROM users<br />
    &lt;/select&gt;

    &lt;insert id="insertUser" parameterType="User"&gt;<br />
        INSERT INTO users (firstName, lastName, email)<br />
        VALUES (#{firstName}, #{lastName}, #{email})<br />
    &lt;/insert&gt;

    &lt;update id="updateUser" parameterType="User"&gt;<br />
        UPDATE users SET<br />
            firstName = #{firstName},<br />
            lastName = #{lastName},<br />
            email = #{email}<br />
        WHERE ID = #{id}<br />
    &lt;/update&gt;<br />
&lt;/mapper&gt;</pre>
</td>
</tr>
</tbody>
</table>
<p>That&rsquo;s pretty much all there is to it. If you find something I left out, please let me know. The full source code for this example resides in the&nbsp;<a href="https://github.com/lanyonm/playground/tree/28c34b185ca796e1e1b18d4134d1a147c6996b97" rel="external nofollow noreferrer">playground</a>&nbsp;repo on GitHub.</p>
<p>http://blog.lanyonm.org/articles/2014/04/21/spring-4-mybatis-java-config.html</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zzx538.html">js点击按钮倒计时setTimeout和setInterval</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yykr3q.html">LCA模板</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mz5kgq.html">IOS中如何获取手机的当前IP</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m7orxq.html">OpenSSL心脏出血漏洞全回顾</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1gxr59.html">iOS视图控制对象生命周期-init、viewDidLoad、viewWillAppear、viewDidAppear、viewWillDisappear、viewDidDisappear的区别及用途</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj0wxy9.html">EasyUI TextBox的keypress</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok7l7p9.html">webservice axis2客户端设置代理方法&lpar;公司网络通过代理访问时）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1wep59.html">JQuery一句话实现全选&sol;反选</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjdlol8.html">Dropbox &plus; Farbox高速创建免费博客小站</a>
		</li>
						<li><a href="https://www.batexi.com/a/9geeg4e8.html">基于struct2完整的用户登录</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo4gnvq.html">1&period;6 在WHERE子句中引用取别名的列</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkrznj8.html">BIOS简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yl26g8.html">【BZOJ2428】均分数据（模拟退火）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pr0my8.html">Dubbo中Directory解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rz6628.html">C&num; 如何获取SQL Server 中指定数据表的所有字段名和字段类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7onp718.html">exporter API（导出、输出器api）moodel3&period;3</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj4d339.html">book项目分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1m4v1q.html">vscode修改code runner插件默认使用的编译器</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25p11lq.html">（转）利用 SVG 和 CSS3 实现有趣的边框动画</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxldv6dq.html">修改 Linux VM 中单个用户最大进程数的限制</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qlmdk1k9.html">Android低功耗蓝牙&lpar;BLE&rpar;开发的一点感受</a>
			</li>
						<li><a href="https://www.batexi.com/a/qde1gm79.html">Weex命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k16r479.html">Spring3 &plus; Spring MVC&plus; Mybatis 3&plus;Mysql 项目整合</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e16rvj9.html">JavaScript实现多栏目切换效果</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2we6elq.html">android--HttpURLConnection&lpar;转载&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1661j9.html">XhProf安装教程&ndash;详细教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydnnljq.html">ZOJ 1234 Chopsticks（动态规划）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k166e79.html">vs2013 使用vs调试器，发现调试器显示的数据错误。查看内存，发现内存是正确的。</a>
			</li>
						<li><a href="https://www.batexi.com/a/qde1v6v9.html">ubuntu 14&period;04安装amd omega 驱动</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k16goj9.html">ubuntu 14&period;04 修改PS1提示符</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
